找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 497|回复: 3

[每日一码] 圆(弧)和多段线圆(弧)相互转换

[复制链接]

已领礼包: 40个

财富等级: 招财进宝

发表于 2017-3-10 10:34:07 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
本帖最后由 newer 于 2017-3-10 13:20 编辑

QQ截图20170310104654.png

  1. (defun c:tt ()
  2.   (xdrx_begin)
  3.   (if (setq ss (ssget ":E:S" '((0 . "CIRCLE,ARC"))))
  4.     (progn
  5.       (setq cir  (ssname ss 0)
  6.             gcir (xdge::constructor cir)
  7.             gPL  (xdge::constructor "kCompositeCrv3d")
  8.       )
  9.       (xdge::setpropertyvalue gPl "setcurvelist" gcir)
  10.       (xdge::entity:make gPl)
  11.       (xdrx_entity_setpropertiesfrom (entlast) cir)
  12.       (xdrx_setpropertyvalue (entlast) "constantwidth" 50.0)
  13.     )
  14.   )
  15.   (xdrx_end)
  16.   (princ)
  17. )


下面代码是反操作,多段线圆(弧)转成 圆(弧)

  1. (defun c:tt ()
  2.   (xdrx_begin)
  3.   (if (and (setq ss (ssget ":E:S" '((0 . "LWPOLYLINE"))))
  4.            (setq cir (ssname ss 0))
  5.            (xdrx_getpropertyvalue cir "hasbulges")
  6.            (setq bulges (xdrx_getpropertyvalue cir "bulges"))
  7.       )
  8.     (progn
  9.       (setq gcir (xdge::constructor cir)
  10.             gPLs (xdge::getpropertyvalue gcir "getcurvelist")
  11.       )
  12.       (if (and (= (length bulges) 2)
  13.                (equal (abs (apply '* bulges)) 1.0 1e-3)
  14.           )
  15.         (progn
  16.           (xdge::getpropertyvalue (car gpls) "center" "radius")
  17.           (xdrx_circle_make #center #radius)
  18.           (xdrx_entity_setpropertiesfrom (entlast) cir)
  19.         )
  20.         (progn
  21.           (mapcar
  22.             '(lambda (x)
  23.                (if (xdge::iskindof x "kCircArc3d")
  24.                  (progn        (xdge::entity:make x)
  25.                         (xdrx_entity_setpropertiesfrom (entlast) cir)
  26.                  )
  27.                )
  28.              )
  29.             gPLs
  30.           )
  31.         )
  32.       )
  33.       (xdrx_entity_delete cir)
  34.     )
  35.   )
  36.   (xdrx_end)
  37.   (princ)
  38. )


论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 35个

财富等级: 招财进宝

发表于 2017-4-21 23:43:02 | 显示全部楼层
谢谢楼主分享,支持下
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-4-26 16:27 , Processed in 0.194962 second(s), 36 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表